package oop.kolokvijum2013.karta.objekti;

public class Drum extends Slozen implements Prohodan {

	private char kategorija;
	private final double AUTOPUT = 120.0;
	private final double MAGISTRALNI = 60.0;
	private final double ZEMLJANI = 30.0;
	private static int brojac = 0;
	
	
	public Drum(String naziv, char kategorija) {
		super(naziv, "D"+(brojac+1), null);
		this.kategorija = kategorija;
		Drum.brojac++;
	}
	
	
	public Drum(String naziv, String id, Kota kota) {
		super(naziv, "D"+(brojac+1), kota);
		Drum.brojac++;
	}


	@Override
	public double duzinaPuta(Kota k1, Kota k2) 
	{
		VezanaKota pom = new VezanaKota(k1.getX(),k1.getY(),k1.getVisina());
		int br=0;
		while(pom.getDesno()!=null && pom.getDesno()!=k2)
		{
			if(pom.getDesno() == k2) br++;
			pom = pom.getDesno();
		}
		if(br == 1)
		{
			pom = (VezanaKota)k1;
			double duzina = 0.0;
			while(pom.getDesno()!=null)
				duzina+=pom.rastojanje(pom.getDesno());
		return duzina;
		}
		return 0.0;
	}

	@Override
	public double procenjenoVremePutovanja(Kota k1, Kota k2) 
	{
		double vreme = 0.0;
		VezanaKota p = (VezanaKota)k1;
		double brzina=0.0;
		if(duzinaPuta(k1, k2)!=0.0)
			while(p.getDesno()!=null && p.getDesno()!=k2)
			{
				if(this.kategorija=='A')  brzina = this.AUTOPUT;
				else if(this.kategorija=='M')  brzina = this.MAGISTRALNI;
				else if(this.kategorija=='Z')  brzina = this.ZEMLJANI;
				vreme += duzinaPuta(p, p.getDesno())/brzina;
			}
		return vreme;
	}


	public void dodajKotu(double x, double y, double visina) 
	{
		VezanaKota pom;
		VezanaKota k = new VezanaKota(x, y, visina);
		VezanaKota k1 = (VezanaKota)this.getKota();
		if(k1 != null) 
		if(k.getDesno()!= null)
		{
			pom = k;
			while(pom.getDesno()!= null) pom = pom.getDesno();
			pom.setDesno(k);
		}
		else this.setKota(k);
	}

	@Override
	public double udaljenost(Objekat o) {
		
		return Kota.rastojanje(this.getKota(), o.getKota());
	}

}
