package oop.kolokvijum2013.karta.objekti;

public class Drum extends Slozen implements Prohodan {
	private char kategorija;
	private final double AUTOPUT = 120.0;
	private final double MAGISTRALNI = 60.0;
	private final double ZEMLJANI = 30.0;
	private static int brojac;

	public Drum(String naziv, char kategorija) {
		super(naziv, "D" + brojac, null);
		this.kategorija = kategorija;
	}

	public Drum(String naziv, char kategorija, VezanaKota pocetna) {
		super(naziv, "D" + brojac, pocetna);
		this.kategorija = kategorija;
	}
	
	public void dodajKotu(double x,double y,double visina) {
		VezanaKota k = new VezanaKota(x, y, visina);
		if (super.getKota()==null) super.setKota(k);
		else {
			VezanaKota pom = (VezanaKota) super.getKota();
			while (pom != null){
				pom = (VezanaKota) pom.getDesno();
			}
			pom = k;
		}
	}
	
	public double procenjenoVremePutovanja(Kota pocetak,Kota kraj){
		if (duzinaPuta(pocetak, kraj) != -1){
			if (this.kategorija == 'A'){
				return duzinaPuta(pocetak,kraj)/AUTOPUT;
			}
			if (this.kategorija == 'M'){
				return duzinaPuta(pocetak,kraj)/MAGISTRALNI;
			}
			if (this.kategorija == 'Z'){
				return duzinaPuta(pocetak,kraj)/ZEMLJANI;
			}
		}
		return -1;
	}
}
