package oop.kolokvijum2013.karta.objekti;

public class Drum extends Slozen implements Prohodan
{
	private char kategorija;
	private static final double AUTOPUT = 120.0, MAGISTRALNI = 60.0, ZEMLJANI = 30.0;
	private static int brojac = 0;
	
	public Drum(String n, char k, Kota kota)
	{
		super(n, "D" + (++brojac), kota);
		kategorija = k;
	}
	
	public Drum(String n, char k)
	{
		this(n, k, null);
	}
	
	@Override
	public double procenjenoVremePutovanja(Kota k1, Kota k2)
	{
		double duzina = duzinaPuta(k1, k2);
		
		switch(kategorija)
		{
		case 'A':
			duzina /= AUTOPUT;
			break;
			
		case 'M':
			duzina /= MAGISTRALNI;
			break;
			
		case 'Z':
			duzina /= ZEMLJANI;
			break;
		}
		
		return duzina;
	}

	@Override
	public void dodajKotu(double x, double y, double v) 
	{
		Kota k = new VezanaKota(x, y, v);
		
		if (getKota() == null)
			setKota(k);
		else
		{
			VezanaKota k1 = (VezanaKota) getKota();
			while (k1.getDesno() != null)
				k1 = (VezanaKota)k1.getDesno();
			k1.setDesno(k);
		}
	}

}
