package oop.kolokvijum2013.karta.objekti;

public class Drum extends Slozen implements Prohodan {
	private char kategorija;
	private final double AUTOPUT=120.0;
	private final double MAGISTRALNI=60.0;
	private final double ZEMLJANI=30.0;
	private static int brDrumova;

	public Drum(String naziv, char kategorija) {
		super(naziv, "D"+(++brDrumova), null);
		this.kategorija=kategorija;
	}
	
	public Drum(String naziv, char kategorija, VezanaKota pk) {
		super(naziv, "D"+(++brDrumova), (Kota)pk);
		this.kategorija=kategorija;
	}

	@Override
	public double procenjenoVremePutovanja(Kota k1, Kota k2) {
		double duzina=super.duzinaPuta(k1, k2);
		if(duzina!=0){
			switch (kategorija) {
			case 'A':
				return duzina/AUTOPUT;
			case 'M':
				return duzina/MAGISTRALNI;
			case 'Z':
				return duzina/ZEMLJANI;
			default:
				break;
			}
		}
		return 0;
	}

	@Override
	public void dodajKotu(double x, double y, double visina) {
		VezanaKota vk=(VezanaKota)this.getKota();
		if(vk==null){
			vk=new VezanaKota(x, y, visina);
			this.setKota((Kota)vk);
		}
		else{
			VezanaKota pom=vk;
			while(pom.getDesno()!=null){
				pom=(VezanaKota)pom.getDesno();
			}
			VezanaKota nova=new VezanaKota(x, y, visina);
			nova.setLevo(pom);
			pom.setDesno(nova);
		}

	}

}
