package oop.kolokvijum2013.karta.objekti;

public class Drum extends Slozen implements Prohodan {
	private char kategorija;
	private final double AUTOPUT = 120.0;
	private final double MAGISTRALNI = 60.0;
	private final double ZEMLJANI = 30.0;
	private static int brojDrumova=0; 
	
	public Drum(String naziv, Kota kota, char kategorija) {
		super(naziv, "D"+(++brojDrumova), kota);
		this.kategorija = kategorija;
	}
	
	public Drum(String naziv, char kategorija){
		super(naziv,"D"+(++brojDrumova),null);
		this.kategorija = kategorija;
		
	}
	

	@Override
	public double procenjenoVremePutovanja(Kota k1, Kota k2) {
		double rez;
		double rastojanje;
		rastojanje = duzinaPuta(k1, k2);
		rez = rastojanje/this.kategorija;
		return rez;
	}

	@Override
	public void dodajKotu(double x, double y, double visina) {
		VezanaKota k = new VezanaKota(x, y, visina);
		VezanaKota pocetna = (VezanaKota) this.getKota();
		if(pocetna == null) pocetna = k;
		else {
			VezanaKota pom = pocetna.getDesno();
			while(pom!=null) pom=pom.getDesno();
			pom=k;
		}

	}

}
